;CodeVisionAVR C Compiler V1.24.2c Professional
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 16,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test02.vec"
	.INCLUDE "test02.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.3 Evaluation
;       4 Automatic Program Generator
;       5  Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : Test des afficheurs borne 50 m
;       9 Version : 3
;      10 Date    : Mai 2010
;      11 Author  : Thierry LEQUEU
;      12 Company : 
;      13 Comments: 
;      14 
;      15 
;      16 Chip type           : ATmega8535
;      17 Program type        : Application
;      18 Clock frequency     : 16,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 128
;      22 *****************************************************/
;      23 
;      24 #include <mega8535.h>   
;      25 #include<stdio.h>
;      26 
;      27 // Alphanumeric LCD Module functions
;      28 #asm
;      29    .equ __lcd_port=0x15 ;PORTC
   .equ __lcd_port=0x15 ;PORTC
;      30 #endasm

;      31 #include <lcd.h>
;      32 #include <delay.h> 
;      33 
;      34 #define BP1 PIND.5
;      35 #define BP2 PIND.6 
;      36 #define ENABLE PORTD.7  // Sur la nouvelle version, il faut ENABLE = OC = 0 pour allumer les afficheurs.
;      37 
;      38 // Declare your global variables here
;      39 flash const unsigned char adresse_constant[16] = 

	.CSEG
;      40 {0,8,4,12,2,10,6,14,1,9,5,13,3,11,7,15};
;      41       
;      42 #define DIGIT_A  64; { bit b6 }
;      43 #define DIGIT_B 128; { bit b7 }
;      44 #define DIGIT_C   2; { bit b1 }
;      45 #define DIGIT_D   4; { bit b2 }
;      46 #define DIGIT_E   8; { bit b3 }
;      47 #define DIGIT_F  32; { bit b5 }
;      48 #define DIGIT_G  16; { bit b4 }
;      49 #define DIGIT_P   1; { bit b0 }
;      50 
;      51 flash const unsigned char valeur_constant[] = 
;      52 {0xEE,0x82,0xDC,0xD6,0xB2,0x76,0x7E,0xC2,0xFE,0xF6,
;      53   0,1,2,4,8,16,32,64,128};
;      54      
;      55 unsigned char tampon[20],seconde,seconde1,temps,temps1,dizaine,unite,dixieme,centieme,test,var,flag;

	.DSEG
_tampon:
	.BYTE 0x14
;      56 
;      57 // Declare your global function  here   
;      58 
;      59 unsigned char USART_Receive( void )
;      60 
;      61 {

	.CSEG
_USART_Receive:
;      62 /* Wait for data to be received */
;      63 while ( !(UCSRA & 0x80) ) // Test de RXC bit7
_0x3:
	SBIS 0xB,7
;      64 ;
	RJMP _0x3
;      65 /* Get and return received data from buffer */
;      66 return UDR;
	IN   R30,0xC
	RET
;      67 }                     
;      68 
;      69 // Timer 1 output compare A interrupt service routine
;      70 interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;      71 {  
_timer1_compa_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      72      
;      73 
;      74 temps++;
	INC  R6
;      75 if (temps>=100) 
	LDI  R30,LOW(100)
	CP   R6,R30
	BRLO _0x6
;      76    {
;      77    temps=0;
	CLR  R6
;      78    seconde++;
	INC  R4
;      79    if (seconde>=60) 
	LDI  R30,LOW(60)
	CP   R4,R30
	BRLO _0x7
;      80       {
;      81       seconde=0;
	CLR  R4
;      82       };
_0x7:
;      83     };
_0x6:
;      84 
;      85         
;      86 if (flag == 1) 
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x8
;      87 {    
;      88    temps1++;
	INC  R7
;      89    if (temps1>=100) 
	LDI  R30,LOW(100)
	CP   R7,R30
	BRLO _0x9
;      90       {
;      91       temps1=0;
	CLR  R7
;      92       seconde1++;
	INC  R5
;      93       if (seconde1>=60) 
	LDI  R30,LOW(60)
	CP   R5,R30
	BRLO _0xA
;      94          {
;      95          seconde1=0;
	CLR  R5
;      96          };
_0xA:
;      97       };
_0x9:
;      98   }
;      99 
;     100 }
_0x8:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     101 
;     102 // Affiche une valeur sur 8 bits  l'adresse de l'afficheur :
;     103 void afficheur1(unsigned char adresse,unsigned char caractere, unsigned char point)
;     104 {
_afficheur1:
;     105   if (point == 1) {
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0xB
;     106       PORTA=(valeur_constant[caractere] | 0x01); // Un caractre avec le point !
	RCALL SUBOPT_0x0
	ORI  R30,1
	RJMP _0x78
;     107      }
;     108      else {   
_0xB:
;     109      PORTA=valeur_constant[caractere]; // Un caractre
	RCALL SUBOPT_0x0
_0x78:
	OUT  0x1B,R30
;     110      }
;     111          
;     112   PORTB=(0b00010000 | adresse_constant[adresse & 0x0F]); // PB7 PB6 PB5 CS A0 A1 A2 A3
	LDI  R30,LOW(_adresse_constant*2)
	LDI  R31,HIGH(_adresse_constant*2)
	PUSH R31
	PUSH R30
	LDD  R30,Y+2
	ANDI R30,LOW(0xF)
	POP  R26
	POP  R27
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	ORI  R30,0x10
	OUT  0x18,R30
;     113   PORTB.4=1;
	SBI  0x18,4
;     114   PORTB.4=0;  // CS = 0
	CBI  0x18,4
;     115   PORTB.4=1;    
	SBI  0x18,4
;     116   PORTA=0x00;
	RCALL SUBOPT_0x1
;     117 }
	ADIW R28,3
	RET
;     118 
;     119 void main(void)
;     120 {
_main:
;     121 // Declare your local variables here
;     122 
;     123 // Input/Output Ports initialization
;     124 // Port A initialization
;     125 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     126 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     127 PORTA=0x00;
	RCALL SUBOPT_0x1
;     128 // DDRA=0x00; en entre
;     129 DDRA=0xFF; // en sortie
	LDI  R30,LOW(255)
	OUT  0x1A,R30
;     130 
;     131 // Port B initialization
;     132 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     133 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     134 PORTB=0xFF;
	RCALL SUBOPT_0x2
;     135 // DDRB=0x00; en entre
;     136 DDRB=0xFF; // en sortie
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     137 
;     138 // Port C initialization
;     139 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     140 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     141 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     142 DDRC=0x00;
	OUT  0x14,R30
;     143 
;     144 // Port D initialization
;     145 // Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     146 // State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     147 PORTD=0x80;
	LDI  R30,LOW(128)
	OUT  0x12,R30
;     148 ENABLE=1;
	SBI  0x12,7
;     149 DDRD=0x80;
	OUT  0x11,R30
;     150            
;     151 // Timer/Counter 0 initialization
;     152 // Clock source: System Clock
;     153 // Clock value: Timer 0 Stopped
;     154 // Mode: Normal top=FFh
;     155 // OC0 output: Disconnected
;     156 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     157 TCNT0=0x00;
	OUT  0x32,R30
;     158 OCR0=0x00;
	OUT  0x3C,R30
;     159 
;     160 // Timer/Counter 1 initialization
;     161 // Clock source: System Clock
;     162 // Clock value: 2000,000 kHz
;     163 // Mode: CTC top=OCR1A
;     164 // OC1A output: Toggle
;     165 // OC1B output: Discon.
;     166 // Noise Canceler: Off
;     167 // Input Capture on Falling Edge
;     168 // Timer 1 Overflow Interrupt: Off
;     169 // Input Capture Interrupt: Off
;     170 // Compare A Match Interrupt: On
;     171 // Compare B Match Interrupt: Off
;     172 TCCR1A=0x40;
	LDI  R30,LOW(64)
	OUT  0x2F,R30
;     173 TCCR1B=0x0A;
	LDI  R30,LOW(10)
	OUT  0x2E,R30
;     174 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     175 TCNT1L=0x00;
	OUT  0x2C,R30
;     176 ICR1H=0x00;
	OUT  0x27,R30
;     177 ICR1L=0x00;
	OUT  0x26,R30
;     178 OCR1AH=0x4E; // Base de temps = 2 MHz, soit 0,5 us.
	LDI  R30,LOW(78)
	OUT  0x2B,R30
;     179 OCR1AL=0x20; // Interruption quand on arrive  20 000 (0x4E20 soit 10 ms)
	LDI  R30,LOW(32)
	OUT  0x2A,R30
;     180 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     181 OCR1BL=0x00;
	OUT  0x28,R30
;     182 
;     183 // Timer/Counter 2 initialization
;     184 // Clock source: System Clock
;     185 // Clock value: Timer 2 Stopped
;     186 // Mode: Normal top=FFh
;     187 // OC2 output: Disconnected
;     188 ASSR=0x00;
	OUT  0x22,R30
;     189 TCCR2=0x00;
	OUT  0x25,R30
;     190 TCNT2=0x00;
	OUT  0x24,R30
;     191 OCR2=0x00;
	OUT  0x23,R30
;     192 
;     193 // External Interrupt(s) initialization
;     194 // INT0: Off
;     195 // INT1: Off
;     196 // INT2: Off
;     197 MCUCR=0x00;
	OUT  0x35,R30
;     198 MCUCSR=0x00;
	OUT  0x34,R30
;     199 
;     200 // Timer(s)/Counter(s) Interrupt(s) initialization
;     201 TIMSK=0x10;
	LDI  R30,LOW(16)
	OUT  0x39,R30
;     202 
;     203 // Analog Comparator initialization
;     204 // Analog Comparator: Off
;     205 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     206 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     207 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     208              
;     209 // USART initialization
;     210 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     211 // USART Receiver: On
;     212 // USART Transmitter: Off
;     213 // USART Mode: Asynchronous
;     214 // USART Baud rate: 9600
;     215 UCSRA=0x00;
	OUT  0xB,R30
;     216 UCSRB=0x10;
	LDI  R30,LOW(16)
	OUT  0xA,R30
;     217 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     218 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     219 UBRRL=0x67;
	LDI  R30,LOW(103)
	OUT  0x9,R30
;     220 
;     221 // LCD module initialization
;     222 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     223 
;     224 /* switch to writing in Display RAM */
;     225 lcd_gotoxy(0,0);
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x3
	RCALL _lcd_gotoxy
;     226 lcd_putsf("Borne DEpart");
	__POINTW1FN _0,0
	RCALL SUBOPT_0x4
;     227 lcd_gotoxy(0,1);
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x5
	RCALL _lcd_gotoxy
;     228 lcd_putsf("Borne 50 m DA");                         
	__POINTW1FN _0,13
	RCALL SUBOPT_0x4
;     229 
;     230 PORTB=0xFF;
	RCALL SUBOPT_0x2
;     231 seconde=0;
	CLR  R4
;     232 temps=0;
	CLR  R6
;     233 seconde1=0;
	CLR  R5
;     234 temps1=0;      
	CLR  R7
;     235 test=0;
	CLR  R12
;     236 var='0';
	LDI  R30,LOW(48)
	MOV  R13,R30
;     237 
;     238 
;     239 
;     240 
;     241 
;     242  ENABLE=0; //Afficheurs on !
	CBI  0x12,7
;     243 
;     244 afficheur1(0,11,0); // Un caractre
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x6
	RCALL _afficheur1
;     245 afficheur1(1,11,0); // Un caractre
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
;     246 afficheur1(2,11,0); // Un caractre
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
;     247 afficheur1(3,11,0); // Un caractre
	RCALL SUBOPT_0x6
	RCALL _afficheur1
;     248    
;     249 // Global enable interrupts
;     250 #asm("sei")
	sei
;     251 
;     252 while (1) 
_0xD:
;     253       { 
;     254       var=USART_Receive();
	RCALL _USART_Receive
	MOV  R13,R30
;     255       
;     256         
;     257       if(var=='0')
	LDI  R30,LOW(48)
	CP   R30,R13
	BRNE _0x10
;     258       {
;     259       flag=0;
	CLR  R14
;     260       }
;     261       if(BP1==0)
_0x10:
	SBIC 0x10,5
	RJMP _0x11
;     262       {
;     263       flag=1;
	LDI  R30,LOW(1)
	MOV  R14,R30
;     264       }
;     265       if(BP2==0)
_0x11:
	SBIS 0x10,6
;     266       {
;     267       flag=0;
	CLR  R14
;     268       }    
;     269       if((BP1==0)&&(BP2==0))
	SBIC 0x10,5
	RJMP _0x14
	SBIS 0x10,6
	RJMP _0x15
_0x14:
	RJMP _0x13
_0x15:
;     270       {
;     271        	temps1=0;
	CLR  R7
;     272        	seconde1=0; 
	CLR  R5
;     273        	flag=0;
	CLR  R14
;     274        	delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     275       }
;     276       
;     277       // Place your code here
;     278       
;     279       sprintf(tampon,"Temps = %2d:%2d",seconde,temps);
_0x13:
	RCALL SUBOPT_0x9
	__POINTW1FN _0,27
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R4
	RCALL SUBOPT_0xA
	MOV  R30,R6
	RCALL SUBOPT_0xA
	LDI  R24,8
	RCALL SUBOPT_0xB
;     280       lcd_gotoxy(0,2);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
;     281       lcd_puts(tampon); 
	RCALL _lcd_puts
;     282       
;     283       sprintf(tampon,"flag = %d,%d",flag,var);
	RCALL SUBOPT_0x9
	__POINTW1FN _0,43
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R14
	RCALL SUBOPT_0xA
	MOV  R30,R13
	RCALL SUBOPT_0xA
	LDI  R24,8
	RCALL SUBOPT_0xB
;     284       lcd_gotoxy(0,3);
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL SUBOPT_0xD
;     285       lcd_puts(tampon);  
	RCALL _lcd_puts
;     286               
;     287       dizaine  = seconde1/10;
	MOV  R26,R5
	RCALL SUBOPT_0xE
	MOV  R8,R30
;     288       unite    = seconde1-dizaine*10;
	MOV  R26,R8
	RCALL SUBOPT_0xF
	MOV  R26,R30
	MOV  R30,R5
	SUB  R30,R26
	MOV  R9,R30
;     289       dixieme  = temps1/10;
	MOV  R26,R7
	RCALL SUBOPT_0xE
	MOV  R10,R30
;     290       centieme = temps1-dixieme*10;
	MOV  R26,R10
	RCALL SUBOPT_0xF
	MOV  R26,R30
	MOV  R30,R7
	SUB  R30,R26
	MOV  R11,R30
;     291       // Afficheur d'adresse 0
;     292       if (dizaine == 0) {
	TST  R8
	BRNE _0x16
;     293          afficheur1(0,13,0);
	RCALL SUBOPT_0x3
	LDI  R30,LOW(13)
	ST   -Y,R30
	RJMP _0x79
;     294          }
;     295          else {
_0x16:
;     296          afficheur1(0,dizaine,0); // Caractre des dizaines.
	RCALL SUBOPT_0x3
	ST   -Y,R8
_0x79:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _afficheur1
;     297          }
;     298       // Afficheur d'adresse 1
;     299       afficheur1(1,unite,1); // Caractre des units.
	RCALL SUBOPT_0x5
	ST   -Y,R9
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
;     300       // Afficheur d'adresse 2
;     301       afficheur1(2,dixieme,0); // Caractre des diximes.
	ST   -Y,R10
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x8
;     302       // Afficheur d'adresse 3
;     303       afficheur1(3,centieme,0); // Caractre des centimes.
	ST   -Y,R11
	RCALL SUBOPT_0x3
	RCALL _afficheur1
;     304 
;     305       
;     306       };
	RJMP _0xD
;     307 }
_0x18:
	RJMP _0x18
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	put:
	RCALL SUBOPT_0x10
	SBIW R30,0
	BREQ _0x19
	RCALL SUBOPT_0x10
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x1A
_0x19:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x1A:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x1B:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x1D
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x21
	CPI  R19,37
	BRNE _0x22
	LDI  R16,LOW(1)
	RJMP _0x23
_0x22:
	RCALL SUBOPT_0x11
_0x23:
	RJMP _0x20
_0x21:
	CPI  R30,LOW(0x1)
	BRNE _0x24
	CPI  R19,37
	BRNE _0x25
	RCALL SUBOPT_0x11
	LDI  R16,LOW(0)
	RJMP _0x20
_0x25:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x26
	LDI  R17,LOW(1)
	RJMP _0x20
_0x26:
	CPI  R19,43
	BRNE _0x27
	LDI  R21,LOW(43)
	RJMP _0x20
_0x27:
	CPI  R19,32
	BRNE _0x28
	LDI  R21,LOW(32)
	RJMP _0x20
_0x28:
	RJMP _0x29
_0x24:
	CPI  R30,LOW(0x2)
	BRNE _0x2A
_0x29:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x2B
	ORI  R17,LOW(128)
	RJMP _0x20
_0x2B:
	RJMP _0x2C
_0x2A:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x20
_0x2C:
	CPI  R19,48
	BRLO _0x2F
	CPI  R19,58
	BRLO _0x30
_0x2F:
	RJMP _0x2E
_0x30:
	MOV  R26,R20
	RCALL SUBOPT_0xF
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x20
_0x2E:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x34
	RCALL SUBOPT_0x12
	LD   R30,X
	RCALL SUBOPT_0x13
	RJMP _0x35
_0x34:
	CPI  R30,LOW(0x73)
	BRNE _0x37
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x14
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x38
_0x37:
	CPI  R30,LOW(0x70)
	BRNE _0x3A
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x14
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x38:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x3B
_0x3A:
	CPI  R30,LOW(0x64)
	BREQ _0x3E
	CPI  R30,LOW(0x69)
	BRNE _0x3F
_0x3E:
	ORI  R17,LOW(4)
	RJMP _0x40
_0x3F:
	CPI  R30,LOW(0x75)
	BRNE _0x41
_0x40:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x42
_0x41:
	CPI  R30,LOW(0x58)
	BRNE _0x44
	ORI  R17,LOW(8)
	RJMP _0x45
_0x44:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x73
_0x45:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x42:
	SBRS R17,2
	RJMP _0x47
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x15
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x48
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x48:
	CPI  R21,0
	BREQ _0x49
	SUBI R16,-LOW(1)
	RJMP _0x4A
_0x49:
	ANDI R17,LOW(251)
_0x4A:
	RJMP _0x4B
_0x47:
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x15
_0x4B:
_0x3B:
	SBRC R17,0
	RJMP _0x4C
_0x4D:
	CP   R16,R20
	BRSH _0x4F
	SBRS R17,7
	RJMP _0x50
	SBRS R17,2
	RJMP _0x51
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x52
_0x51:
	LDI  R19,LOW(48)
_0x52:
	RJMP _0x53
_0x50:
	LDI  R19,LOW(32)
_0x53:
	RCALL SUBOPT_0x11
	SUBI R20,LOW(1)
	RJMP _0x4D
_0x4F:
_0x4C:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x54
_0x55:
	CPI  R18,0
	BREQ _0x57
	SBRS R17,3
	RJMP _0x58
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x7A
_0x58:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x7A:
	ST   -Y,R30
	RCALL SUBOPT_0x16
	CPI  R20,0
	BREQ _0x5A
	SUBI R20,LOW(1)
_0x5A:
	SUBI R18,LOW(1)
	RJMP _0x55
_0x57:
	RJMP _0x5B
_0x54:
_0x5D:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x5F
	SBRS R17,3
	RJMP _0x60
	SUBI R19,-LOW(7)
	RJMP _0x61
_0x60:
	SUBI R19,-LOW(39)
_0x61:
_0x5F:
	SBRC R17,4
	RJMP _0x63
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x65
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x64
_0x65:
	ORI  R17,LOW(16)
	RJMP _0x67
_0x64:
	CP   R20,R18
	BRLO _0x69
	SBRS R17,0
	RJMP _0x6A
_0x69:
	RJMP _0x68
_0x6A:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x6B
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x67:
	SBRS R17,2
	RJMP _0x6C
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x16
	CPI  R20,0
	BREQ _0x6D
	SUBI R20,LOW(1)
_0x6D:
_0x6C:
_0x6B:
_0x63:
	RCALL SUBOPT_0x11
	CPI  R20,0
	BREQ _0x6E
	SUBI R20,LOW(1)
_0x6E:
_0x68:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x5E
	RJMP _0x5D
_0x5E:
_0x5B:
	SBRS R17,0
	RJMP _0x6F
_0x70:
	CPI  R20,0
	BREQ _0x72
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x13
	RJMP _0x70
_0x72:
_0x6F:
_0x73:
_0x35:
	LDI  R16,LOW(0)
_0x20:
	RJMP _0x1B
_0x1D:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	__PUTW2R 16,17
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x17
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x17
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G2
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G3:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G3:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G3)
	SBCI R31,HIGH(-__base_y_G3)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x18
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	RCALL SUBOPT_0xC
	RCALL __lcd_write_data
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x18
	RCALL __lcd_ready
	RCALL SUBOPT_0x5
	RCALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0x75
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0x3
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x75:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
_lcd_putsf:
    ld   r30,y
    ldd  r31,y+1
__lcd_putsf0:
	lpm
    tst  r0
    breq __lcd_putsf1
    adiw r30,1
    st   -y,r0
    rcall _lcd_putchar
    rjmp __lcd_putsf0
__lcd_putsf1:
	ADIW R28,2
	RET
__long_delay_G3:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G3:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G3,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G3,3
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x19
	RCALL __long_delay_G3
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G3
	RCALL __long_delay_G3
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x18
	RCALL __long_delay_G3
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x18
	RCALL __long_delay_G3
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x18
	RCALL __long_delay_G3
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G3
	CPI  R30,LOW(0x5)
	BREQ _0x76
	LDI  R30,LOW(0)
	RJMP _0x77
_0x76:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x18
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x77:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LDI  R26,LOW(_valeur_constant*2)
	LDI  R27,HIGH(_valeur_constant*2)
	LDD  R30,Y+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(255)
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(11)
	ST   -Y,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	RCALL _afficheur1
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	RCALL _afficheur1
	LDI  R30,LOW(3)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(_tampon)
	LDI  R31,HIGH(_tampon)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xA:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	RCALL _sprintf
	ADIW R28,12
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	RCALL _lcd_gotoxy
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x11:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x12:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x18:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x19:
	RCALL __long_delay_G3
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G3

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

